/*
 * Temperature.java
 */

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.text.*;

public class Temperature extends JFrame 
{
	static JLabel degreesFLabel = new JLabel();
  static JTextField degreesFTextField = new JTextField();
	static JPanel colorPanel = new JPanel();
	static JScrollBar temperatureScrollBar = new JScrollBar();
  static JLabel degreesCLabel = new JLabel();
  static JTextField degreesCTextField = new JTextField();

  static boolean isHot = false;

	public static void main(String args[]) 
  {
    // create frame
    new Temperature().show();
  }

  public Temperature() 
  {
    // frame constructor
    setTitle("Temperature Conversion");
    setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent evt) 
      {
        exitForm(evt);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
    // position controls
    GridBagConstraints gridConstraints;
    degreesFLabel.setText("Fahrenheit");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(0, 10, 0, 0);
    getContentPane().add(degreesFLabel, gridConstraints);
    degreesFTextField.setText("32.0");
    degreesFTextField.setColumns(10);
    degreesFTextField.setHorizontalAlignment(SwingConstants.CENTER);
    degreesFTextField.setEditable(false);
    degreesFTextField.setBackground(Color.WHITE);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
    getContentPane().add(degreesFTextField, gridConstraints);
    
    degreesCLabel.setText("Celsius");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    gridConstraints.insets = new Insets(0, 10, 0, 0);
    getContentPane().add(degreesCLabel, gridConstraints);
    degreesCTextField.setText("0.0");
    degreesCTextField.setColumns(10);
    degreesCTextField.setHorizontalAlignment(SwingConstants.CENTER);
    degreesCTextField.setEditable(false);
    degreesCTextField.setBackground(Color.WHITE);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 2;
    getContentPane().add(degreesCTextField, gridConstraints);

    colorPanel.setBackground(Color.BLUE);
    colorPanel.setPreferredSize(new Dimension (280, 40));
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    gridConstraints.gridwidth = 2;
    getContentPane().add(colorPanel, gridConstraints);
		temperatureScrollBar.setMinimum(-600);
		temperatureScrollBar.setMaximum(1200 + temperatureScrollBar.getVisibleAmount());
		temperatureScrollBar.setBlockIncrement(10);
		temperatureScrollBar.setUnitIncrement(1);
		temperatureScrollBar.setValue(320);
		temperatureScrollBar.setOrientation(JScrollBar.HORIZONTAL);
    temperatureScrollBar.setPreferredSize(new Dimension (200, 30));
    colorPanel.add(temperatureScrollBar);
    temperatureScrollBar.addAdjustmentListener(new AdjustmentListener()
    {
      public void adjustmentValueChanged(AdjustmentEvent e) 
      {
        temperatureScrollBarAdjustmentValueChanged(e);
      }
    });
	
   
    pack();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());
   
  }
  private void temperatureScrollBarAdjustmentValueChanged(AdjustmentEvent e)
  {
		double tempF, tempC;
    // Read F and convert to C - divide by 10 needed since value is tenths of degrees
    tempF = (double) temperatureScrollBar.getValue() / 10;
    //check to see if changed from hot to cold or vice versa
    if (isHot && tempF < 70)
    {
      // changed to cold
      isHot = false;
      colorPanel.setBackground(Color.BLUE);
    }
    else if (!isHot && tempF >= 70)
    { 
      //changed to hot
      isHot = true;
      colorPanel.setBackground(Color.RED);
		}
		degreesFTextField.setText(new DecimalFormat("0.0").format(tempF));
    tempC = (tempF - 32.0) * 5.0 / 9.0;
    degreesCTextField.setText(new DecimalFormat("0.0").format(tempC));
  }

  private void exitForm(WindowEvent evt) 
  {
    System.exit(0);
  }
}
